<?
 
/* gestion_informations.php
 * - Page de modification des informations (pour l'adhrent)
 * Copyright (c) 2003 Frdric Jacquot
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
 
	include("includes/config.inc.php"); 
	include("includes/session.inc.php"); 
 	include("includes/database.inc.php"); 
 	include("includes/functions.inc.php");
	
	if ($_SESSION["logged_status"]==0) 
		header("location: index.php");
	else
		$id_adh = $_SESSION["logged_id_adh"];
		
	// variables d'erreur (pour affichage)	    
 	$error_detected = "";
 	$warning_detected = "";
 	$confirm_detected = "";

	    
	  //
	 // DEBUT parametrage des champs
  //  On recupere de la base la longueur et les flags des champs
  //  et on initialise des valeurs par defaut
    
  // recuperation de la liste de champs de la table
  $fields = &$DB->MetaColumns("adherents");
  while (list($champ, $proprietes) = each($fields))
	{
		$proprietes_arr = get_object_vars($proprietes);
		// on obtient name, max_length, type, not_null, has_default, primary_key,
		// auto_increment et binary		
		
		$fieldname = $proprietes_arr["name"];
				
	  // definissons  aussi la longueur des input text
	  $max_tmp = $proprietes_arr["max_length"];
	  if ($max_tmp == "-1")
	  	$max_tmp = 10;
	  eval("\$".$fieldname."_len = ".$max_tmp.";");

	  // et s'ils sont obligatoires ( partir de la base)
	  if ($proprietes_arr["not_null"]==1)
		  eval("\$".$fieldname."_req = \"style=\\\"color: #FF0000;\\\"\";");
		else
		  eval("\$".$fieldname."_req = \"\";");
	}
	reset($fields);

	  //
	 // FIN parametrage des champs
	// 	    	    
    
    //
   // Validation du formulaire
  //
  
  if (isset($_POST["valid"]))
  {
  	// verification de champs
  	$update_string = "";
  	$insert_string_fields = "";
  	$insert_string_values = "";
  
  	// recuperation de la liste de champs de la table
	  while (list($champ, $proprietes) = each($fields))
		{
			$proprietes_arr = get_object_vars($proprietes);
			// on obtient name, max_length, type, not_null, has_default, primary_key,
			// auto_increment et binary		
		
			$fieldname = $proprietes_arr["name"];
				
			// on ne met jamais a jour date_crea_adh, id_adh, titre_adh, nom_adh
			// prenom_adh, id_statut, id_societe_adh, activite_adh, bool_admin_adh
			if ($fieldname!="date_crea_adh" && 
					$fieldname!="id_adh"  && 
					$fieldname!="titre_adh" && 
					$fieldname!="id_statut" &&
					$fieldname!="activite_adh" &&
					$fieldname!="bool_exempt_adh" &&
					$fieldname!="bool_admin_adh" &&
					$fieldname!="info_adh")
			{			
				if (isset($_POST[$fieldname]))
				  $post_value=trim($_POST[$fieldname]);
				else			
					$post_value="";

				// on declare les variables pour la prsaisie en cas d'erreur
			  eval("\$".$fieldname." = \"".$post_value."\";");

				// vrification de la prsence des champs obligatoires
				eval("\$req = \$" . $fieldname . "_req;");
				if ($req!="" && $post_value=="")
				  $error_detected .= "- Champs obligatoire non renseign.<BR>";
				else
				{
					// validation des dates				
					if($proprietes_arr["type"]=="date" && $post_value!="")
					{
					  if (ereg("^([0-9]{2})/([0-9]{2})/([0-9]{4})$", $post_value, $array_jours) || $post_value=="")
					  {
						  if (checkdate($array_jours[2],$array_jours[1],$array_jours[3]) || $post_value=="")
							  $value=txt_sqls("$array_jours[3]-$array_jours[2]-$array_jours[1]");
							else
								$error_detected .= "- Date non valide !<BR>";
					  }
					  else
					  	$error_detected .= "- Mauvais format de date (jj/mm/aaaa) !<BR>";
					}
					elseif ($fieldname=="email_adh")
 					{
 						$post_value=strtolower($post_value);
						if (!is_valid_email($post_value) && $post_value!="")
					  	$error_detected .= "- Adresse E-mail non valide !<BR>";
						else
		 					$value = txt_sqls(htmlspecialchars($post_value,ENT_QUOTES));
					}
					elseif ($fieldname=="url_adh")
 					{
 						if (!is_valid_web_url($post_value) && $post_value!="")
					  	$error_detected .= "- Adresse web non valide ! Oubli du http:// ?<BR>";
						else
		 					$value = txt_sqls(htmlspecialchars($post_value,ENT_QUOTES));
					}
 					elseif ($fieldname=="login_adh")
 					{
 						if (strlen($post_value)<4)
 							$error_detected .= "- L'identifiant doit tre compos d'au moins 4 caractres !<BR>";
 						else
 						{
 							// on vrifie que le login n'est pas dj utilis
 							$requete = "SELECT id_adh
 													FROM adherents
 													WHERE login_adh=" . txt_sqls($post_value) . " ";
 							if ($id_adh!="")
 								$requete .= "AND id_adh!=" . txt_sqls($id_adh);
 															
 							$result = &$DB->Execute($requete);
							if (!$result->EOF || $post_value==ADMIN_LOGIN)
	 							$error_detected .= "- Cet identifiant est dj utilis par un autre adhrent !<BR>";
							else
	 							$value = txt_sqls(htmlspecialchars($post_value,ENT_QUOTES));
						}
 					}
 					elseif ($fieldname=="mdp_adh")
 					{
 						if (strlen($post_value)<4)
 							$error_detected .= "- Le mot de passe doit tre compos d'au moins 4 caractres !<BR>";
 						else
 							$value = txt_sqls(htmlspecialchars($post_value,ENT_QUOTES));
 					}
 					else
 					{
 						// on se contente d'escaper le html et les caracteres speciaux
							$value = txt_sqls(htmlspecialchars($post_value,ENT_QUOTES));
					}

					// mise  jour des chaines d'insertion/update
					if ($value=="''")
						$value="NULL";
					
					// aucune chance d'update nom ou prenom
					if ($fieldname!="nom_adh" &&
							$fieldname!="prenom_adh")
					{
						$update_string .= ",".$fieldname."=".$value;
						$insert_string_fields .= ",".$fieldname;
						$insert_string_values .= ",".$value;		
					}
				}
			}
		}
		reset($fields);
  
  	// modif ou ajout
  	if ($error_detected=="")
  	{  	 		 		
 		 	$requete = "UPDATE adherents
 		 								SET " . substr($update_string,1) . " 
 		 								WHERE id_adh=" . $id_adh;
			$DB->Execute($requete);
			$confirm_detected = "Modifications effectues !";
			if (isset($_FILES["photo"]["tmp_name"]))
                        if ($_FILES["photo"]["tmp_name"]!="none" &&
                            $_FILES["photo"]["tmp_name"]!="") 
			{ 
				if ($_FILES['photo']['type']=="image/jpeg" || 
				    $_FILES['photo']['type']=="image/gif" || 
				    $_FILES['photo']['type']=="image/png" ||
				    $_FILES['photo']['type']=="image/x-png")
				{
					$tmp_name = $HTTP_POST_FILES["photo"]["tmp_name"];
						
					// extension du fichier (en fonction du type mime)
					if ($_FILES['photo']['type']=="image/jpeg")
						$ext_image = ".jpg";
					if ($_FILES['photo']['type']=="image/png" || $_FILES['photo']['type']=="image/x-png")
						$ext_image = ".png";
					if ($_FILES['photo']['type']=="image/gif")
						$ext_image = ".gif";
						
					// suppression ancienne photo
					// NB : une verification sur le type de $id_adh permet d'eviter une faille
					//      du style $id_adh = "../../../image"
					@unlink(WEB_ROOT . "photos/".$id_adh.".jpg");
					@unlink(WEB_ROOT . "photos/".$id_adh.".gif");
					@unlink(WEB_ROOT . "photos/".$id_adh.".jpg");
						
					// copie fichier temporaire				 		
					if (!@move_uploaded_file($tmp_name,WEB_ROOT . "photos/".$id_adh.$ext_image))
					$warning_detected .= "- La photo semble ne pas avoir t transmise correstement. L'enregistrement a cependant t effectu.<BR>";
				 		
			 	}
			 	else
			 		$warning_detected .= "- Le fichier transmis n'est pas une image valide (GIF, PNG ou JPEG). L'enregistrement a cependant t effectu.<BR>"; 
			}
  	}  	
  }
  
 	// suppression photo
	if (isset($_POST["del_photo"]))
  {
 		@unlink(WEB_ROOT . "photos/" . $id_adh . ".jpg");
 		@unlink(WEB_ROOT . "photos/" . $id_adh . ".png");
 		@unlink(WEB_ROOT . "photos/" . $id_adh . ".gif");
 	} 	
	
	  //	
	 // Pr-remplissage des champs
	//  avec des valeurs issues de la base
	//  -> donc uniquement si l'enregistrement existe et que le formulaire
	//     n'a pas dja t post avec des erreurs (pour pouvoir corriger)
	
	if (!isset($_POST["valid"]) || (isset($_POST["valid"]) && $error_detected==""))
	{
		// recup des donnes
		$requete = "SELECT * 
			    FROM adherents 
			    WHERE id_adh=$id_adh";
		$result = &$DB->Execute($requete);
		
		// recuperation de la liste de champs de la table
	  //$fields = &$DB->MetaColumns("cotisations");
	  while (list($champ, $proprietes) = each($fields))
		{
			$val="";
			$proprietes_arr = get_object_vars($proprietes);
			// on obtient name, max_length, type, not_null, has_default, primary_key,
			// auto_increment et binary		
		
		  // dclaration des variables correspondant aux champs
		  // et reformatage des dates.
			
			// on doit faire cette verif pour une enventuelle valeur "NULL"
			// non renvoye -> ex: pas de societe membre
			// sinon on obtient un warning
			if (isset($result->fields[$proprietes_arr["name"]]))
				$val = $result->fields[$proprietes_arr["name"]];

			if($proprietes_arr["type"]=="date" && $val!="")
			{
			  list($a,$m,$j)=split("-",$val);
			  $val="$j/$m/$a";
			}
		  eval("\$".$proprietes_arr["name"]." = \"".$val."\";");		  
		}
		reset($fields);
	}

	include("header.php");

?> 
 
						<form action="gestion_informations.php" method="post" enctype="multipart/form-data"> 
						<br>
						<div class="titre">Mes informations</div>
						
<?
	// Affichage des erreurs
	if ($error_detected!="")
  	echo "<BR><DIV align=\"center\"><TABLE><TR><TD style=\"background: #FFDDDD; color: #FF0000\"><B><DIV align=\"center\">- ERREUR -</DIV></B>" . $error_detected . "</TD></TR></TABLE></DIV>";
	if ($warning_detected!="")
	 	echo "<BR><DIV align=\"center\"><TABLE><TR><TD style=\"background: #FFDDDD; color: #FF0000\"><B><DIV align=\"center\">- AVERTISSEMENT -</DIV></B>" . $warning_detected . "</TD></TR></TABLE></DIV>";
	if ($confirm_detected!="")
	 	echo "<BR><DIV align=\"center\"><TABLE><TR><TD style=\"background:#DDFFDD; color: #FF0000\"><B><DIV align=\"center\">- CONFIRMATION -</DIV></B>" . $confirm_detected . "</TD></TR></TABLE></DIV>";

?>						
						<BLOCKQUOTE>
						<div align="center">
						<table border="0"> 
							<tr> 
								<td <? echo $nom_adh_req ?>>Nom :</td> 
								<td><input type="text" name="nom_adh" value="<? echo $nom_adh; ?>" maxlength="<? echo $nom_adh_len; ?>" disabled></td> 
								<td colspan="2" rowspan="5" align="center">
								<?
									$image_adh = "";
									if (file_exists(WEB_ROOT . "photos/" . $id_adh . ".jpg"))
										$image_adh = "photos/" . $id_adh . ".jpg";
									if (file_exists(WEB_ROOT . "photos/" . $id_adh . ".gif"))
										$image_adh = "photos/" . $id_adh . ".gif";
									if (file_exists(WEB_ROOT . "photos/" . $id_adh . ".png"))
										$image_adh = "photos/" . $id_adh . ".png";
									
									if ($image_adh != "")
									{
								?>
									<img src="<? echo $image_adh ?>" border="1" alt="Photo" width="300">
								<?
									}
									else
										echo "[ pas de photo ]";
								?>	
								</td>
						  </tr>
						  <tr>
								<td<? echo $prenom_adh_req ?>>Prnom :</td> 
								<td><input type="text" name="prenom_adh" value="<? echo $prenom_adh; ?>" maxlength="<? echo $prenom_adh_len; ?>" disabled></td> 
							</tr>						   
							<tr> 
								<td <? echo $pseudo_adh_req ?>>Pseudo :</td> 
								<td><input type="text" name="pseudo_adh" value="<? echo $pseudo_adh; ?>" maxlength="<? echo $pseudo_adh_len; ?>"></td> 
						  </tr> 
							<tr> 
								<td <? echo $ddn_adh_req ?>>Date de naissance :<br>&nbsp;</td> 
								<td><input type="text" name="ddn_adh" value="<? echo $ddn_adh; ?>" maxlength="10"><BR><DIV class="exemple">(format jj/mm/aaaa)</DIV></td>
							</tr>
							<tr>
							  <td <? echo $prof_adh_req ?>>Profession :</td> 
								<td><input type="text" name="prof_adh" value="<? echo $prof_adh; ?>" maxlength="<? echo $prof_adh_len; ?>"></td> 
							</tr> 
							<tr>
								<td>&nbsp;</td> 
								<td>&nbsp;</td>
								<td> 
									Photo :  
								</td> 
								<td> 
								<?
									if (file_exists(WEB_ROOT . "photos/" . $id_adh . ".jpg") ||
											file_exists(WEB_ROOT . "photos/" . $id_adh . ".png") ||
											file_exists(WEB_ROOT . "photos/" . $id_adh . ".gif"))
									{
								?>
									<input type="submit" name="del_photo" value="Supprimer la photo">
								<?
									}
									else
									{
								?>
									<input type="file" name="photo"><br>
								<?
									}
								?>
								</td> 
							</tr>
							<tr> 
								<td colspan="4">&nbsp;</td> 
							</tr>
							<tr> 
								<td <? echo $adresse_adh_req ?>>Adresse :</td> 
								<td colspan="3"><input type="text" name="adresse_adh" value="<? echo $adresse_adh; ?>" maxlength="<? echo $adresse_adh_len; ?>" size="63"></td> 
						  </tr> 
							<tr> 
								<td <? echo $cp_adh_req ?>>Code Postal :</td> 
								<td><input type="text" name="cp_adh" value="<? echo $cp_adh; ?>" maxlength="<? echo $cp_adh_len; ?>"></td> 
								<td <? echo $ville_adh_req ?>>Ville :</td> 
								<td><input type="text" name="ville_adh" value="<? echo $ville_adh; ?>" maxlength="<? echo $ville_adh_len; ?>"></td> 
						  </tr> 
							<tr> 
								<td <? echo $tel_adh_req ?>>Tel :</td> 
								<td><input type="text" name="tel_adh" value="<? echo $tel_adh; ?>" maxlength="<? echo $tel_adh_len; ?>"></td> 
								<td <? echo $gsm_adh_req ?>>GSM :</td> 
								<td><input type="text" name="gsm_adh" value="<? echo $gsm_adh; ?>" maxlength="<? echo $gsm_adh_len; ?>"></td> 
						  </tr> 
							<tr> 
								<td <? echo $email_adh_req ?>>E-Mail :</td> 
								<td><input type="text" name="email_adh" value="<? echo $email_adh; ?>" maxlength="<? echo $email_adh_len; ?>" size="30"></td> 
								<td <? echo $url_adh_req ?>>Site Web :</td> 
								<td><input type="text" name="url_adh" value="<? echo $url_adh; ?>" maxlength="<? echo $url_adh_len; ?>" size="30"></td> 
						  </tr> 
							<tr> 
								<td <? echo $msn_adh_req ?>>MSN :</td> 
								<td><input type="text" name="msn_adh" value="<? echo $msn_adh; ?>" maxlength="<? echo $msn_adh_len; ?>" size="30"></td> 
								<td <? echo $icq_adh_req ?>>ICQ :</td> 
								<td><input type="text" name="icq_adh" value="<? echo $icq_adh; ?>" maxlength="<? echo $icq_adh_len; ?>"></td> 
						  </tr> 
							<tr> 
								<td colspan="4">&nbsp;</td> 
							</tr>
							<tr> 
								<td <? echo $login_adh_req ?>>Login :</td> 
								<td><input type="text" name="login_adh" value="<? echo $login_adh; ?>" maxlength="<? echo $login_adh_len; ?>"><BR><DIV class="exemple">(au moins 4 caractres)</DIV></td> 
								<td <? echo $mdp_adh_req ?>>Mot de passe :</td> 
								<td><input type="text" name="mdp_adh" value="<? echo $mdp_adh; ?>" maxlength="<? echo $mdp_adh_len; ?>"><BR><DIV class="exemple">(au moins 4 caractres)</DIV></td> 
						  </tr> 
							<tr> 
								<td align="center" colspan="4"><input type="submit" name="valid" value="Enregistrer"></td> 
						  </tr> 
							</table> 
						</div>
						<br> 
						NB : Les champs obligatoires apparaissent en <font style="color: #FF0000">rouge</font>. 
						</BLOCKQUOTE> 
						<INPUT type="hidden" name="nom_adh" value="<? echo $nom_adh ?>">
						<INPUT type="hidden" name="prenom_adh" value="<? echo $prenom_adh ?>">
						</form> 
<? 
	// } 
 
 
  include("footer.php") 
?>
