<?
	define("GALETTE_VERSION", "v0.55");
	define("MAX_PER_PAGE", "50");
 
	include(WEB_ROOT."/includes/adodb/adodb.inc.php");
	$DB = ADONewConnection(TYPE_DB);
	$DB->debug = false;
	@$DB->Connect(HOST_DB, USER_DB, PWD_DB, NAME_DB);
	
	/* Fonction get_days_left
	 *
	 *   Permet d'obtenir une chaine indiquant le statut de l'adhsion d'un membre
	 *   ainsi que la couleur correspondant  ce statut (pour affichage). Cette
	 *	 fonction a besoin de l'id_adh pour aller rcuprer toutes les cotisations
	 *	 de l'adhrent tries par date (ncessaire pour le calcul).
	 *
	 *	 La fonction va evidemment au pralable vrifier si l'adhrent est exempt
	 *	 de cotisation, soit pas un requete dans la base, soit en utilisant
	 *	 l'argument optionnel $exempt_default, qui soulage la base d'une requete
	 *	 (c'est notamment recommand lorsqu'une requete permettant d'obtenir cette
	 *	 valeur a t effectue avant l'appel  cette fonction)
	 *
	 *	 Le rsultats sont communiqus par le biais des variables $return_text et
	 *   $return_color, passes par rfrence  la fonction.
	 *
	 *	 Enfin, la fonction considre que l'adhrent est exempt de cotisation si
	 *	 la cl fournie n'existe pas dans la base.
	 */
		
	
	function get_days_left ($DB, $cotisant, $exempt_default="") {
		if ($exempt_default=="")
		{
			$requete_cotis = "SELECT bool_exempt_adh
					  FROM adherents
					  WHERE id_adh=" . $cotisant;
			$resultat_cotis = &$DB->Execute($requete_cotis);
			if ($resultat_cotis->EOF)
				$exempt="1";
			else
				$exempt=$resultat_cotis->fields[0];
			$resultat_cotis->Close();
		}	
		else
			$exempt=$exempt_default;
		
		// dfinition couleur pour adherent exempt de cotisation
		if ($exempt=="1")
		{
			$statut_cotis = "Exempt de cotisation";
			$color = "#DDFFDD";
			$cumul = 9999; // jours restants
		}
		else
		{
			$requete_cotis = "SELECT *
					  FROM cotisations
					  WHERE id_adh=" . $cotisant . "
												ORDER BY date_cotis";
			$resultat_cotis = &$DB->Execute($requete_cotis);
			$diff = 0;
			$duree_old = 0;
			$ts_old = 0;
			while (!$resultat_cotis->EOF) 
			{
				// difference avec date precedente
			
				// timestamp actuel
				list($a,$m,$j)=split("-",$resultat_cotis->fields["date_cotis"]);
				$ts = mktime(0,0,0,$m,$j,$a);
			
				// duree cotisation courante (en s)
				$duree = (mktime(0,0,0,$m+$resultat_cotis->fields["duree_mois_cotis"],$j,$a)-mktime(0,0,0,$m,$j,$a));
			
				// diff = (date_prec + duree_prec + diff) - date_courante
				$diff = ($ts_old + $duree_old + $diff)-$ts;
			
				if ($diff < 0)
				  $diff = 0;
			  
				$ts_old = $ts;
				$duree_old = $duree;
				$resultat_cotis->MoveNext();
			}
			$resultat_cotis->Close();
		
			if ($ts_old==0)
			{
				$statut_cotis = "N'a jamais cotis";
				$color = "#EEEEEE";
			}
			else
			{
				$cumul = intval((($ts_old + $duree_old + $diff)-time())/(3600*24));
				if ($cumul<0)
				{
					$statut_cotis = "En retard de ".-$cumul." jours (depuis le ".date("d/m/Y",time()+$cumul*3600*24).")";
					$color = "#FFDDDD";
				}
				elseif ($cumul==0)
				{
					$statut_cotis = "Dernier jour !";
					$color = "#FFDDDD";
				}
				else
				{
					$statut_cotis = $cumul." jours restants (fin le ".date("d/m/Y",time()+$cumul*3600*24).")";
					if ($cumul < 30)
						$color = "#FFE9AB";
					else
						$color = "#DDFFDD";	
				}
			}
		}	

 	 	 //
	  // Fin du calcul du temps d'adhsion
 	 // 
	 	 
 		$return["text"] = $statut_cotis;
	 	$return["color"] = $color;
		$return["cumul"] = $cumul;
		return $return;
	}
	
	function get_echeance ($DB, $cotisant, $exempt_default="") {
		if ($exempt_default=="")
		{
			$requete_cotis = "SELECT bool_exempt_adh
					  FROM adherents
					  WHERE id_adh=" . $cotisant;
			$resultat_cotis = &$DB->Execute($requete_cotis);
			if ($resultat_cotis->EOF)
				$exempt="1";
			else
				$exempt=$resultat_cotis->fields[0];
			$resultat_cotis->Close();
		}	
		else
			$exempt=$exempt_default;
		
		// dfinition couleur pour adherent exempt de cotisation
		if ($exempt=="1")
		{
			$statut_cotis = "Exempt de cotisation";
			$color = "#DDFFDD";
			$cumul = 9999; // jours restants
		}
		else
		{
			$requete_cotis = "SELECT *
					  FROM cotisations
					  WHERE id_adh=" . $cotisant . "
												ORDER BY date_cotis";
			$resultat_cotis = &$DB->Execute($requete_cotis);
			$diff = 0;
			$duree_old = 0;
			$ts_old = 0;
			while (!$resultat_cotis->EOF) 
			{
				// difference avec date precedente
			
				// timestamp actuel
				list($a,$m,$j)=split("-",$resultat_cotis->fields["date_cotis"]);
				$ts = mktime(0,0,0,$m,$j,$a);
			
				// duree cotisation courante (en s)
				$duree = (mktime(0,0,0,$m+$resultat_cotis->fields["duree_mois_cotis"],$j,$a)-mktime(0,0,0,$m,$j,$a));
			
				// diff = (date_prec + duree_prec + diff) - date_courante
				$diff = ($ts_old + $duree_old + $diff)-$ts;
			
				if ($diff < 0)
				  $diff = 0;
			  
				$ts_old = $ts;
				$duree_old = $duree;
				$resultat_cotis->MoveNext();
			}
			$resultat_cotis->Close();
		
			if ($ts_old==0)
			{
				$statut_cotis = "N'a jamais cotis";
				$color = "#EEEEEE";
				return "";
			}
			else
			{
				$cumul = intval((($ts_old + $duree_old + $diff)-time())/(3600*24));
				if ($cumul<0)
				{
					$statut_cotis = "En retard de ".-$cumul." jours (depuis le ".date("d/m/Y",time()+$cumul*3600*24).")";
					$color = "#FFDDDD";
				}
				elseif ($cumul==0)
				{
					$statut_cotis = "Dernier jour !";
					$color = "#FFDDDD";
				}
				else
				{
					$statut_cotis = $cumul." jours restants (fin le ".date("d/m/Y",time()+$cumul*3600*24).")";
					if ($cumul < 30)
						$color = "#FFE9AB";
					else
						$color = "#DDFFDD";	
				}
			}
		}	

 	 	 //
	  // Fin du calcul du temps d'adhsion
 	 // 
	 	 
 		$return["text"] = $statut_cotis;
	 	$return["color"] = $color;
		$return["cumul"] = $cumul;
		$return_date = date("d/m/Y",time()+$cumul*3600*24);
		return split("/",$return_date);
	}
?>
